require "globals"
local scale = 2
local message = ''
local FRICTION = 10
local lastStateW = 'Idling'
local lastStateA = 'Notinair'
local xvr = 0
local xvl = 0
local yv = 0
local viewingVars = false




local player = {}

local player = {
                x = 50,
                y = 50,
                w = 16,
                h = 32,
                speed = 0.85,
                yAcc = 0,
                xAcc = 0,
                vel=4,
                walled = false,
                walledr = false,
                walledl = false,
                canJump = false,
                canCling = false,
                canWallJumpr = false,
                canWallJumpl = false,
                canDash = false,
                endR = false,
                dx = 0,
                dy = 0,
                maxJump = 10,
                gravity = 60,
                isOnGround = false,
                canDash = true

}

local world = bump.newWorld(32)


function love.load()
    
    -- uncomment the line below if using zerobrane debugging (http://notebook.kulchenko.com/zerobrane/love2d-debugging)
    -- if arg[#arg] == "-debug" then require("mobdebug").start() end
    input = Input()
    input:bind('dpright', 'right')
    input:bind('dpleft', 'left')
    input:bind('dpup', 'up')
    input:bind('space', 'jump')
    input:bind('fright', 'jump')
    input:bind('a', 'left')
    input:bind('d', 'right')
    input:bind('s', 'down')
    input:bind('lalt', 'dash')
    input:bind('l1', 'dash')
    input:bind('w', 'up')
    input:bind('lshift', 'sprint')
    input:bind('fdown', 'sprint')
    input:bind('q', 'cling')
    input:bind('r1', 'cling')
    input:bind('escape', 'quit')
    input:bind('back', 'debug')
    input:bind('insert', 'debug')
    map = sti('Assets/Maps/lvl1.lua', {'bump'})
    map:bump_init(world)
    world:add(player, player.x, player.y, player.w, player.h)
    walkStates = machine.create({
  initial = 'idling',
  events = {
    {name = 'idle', from = {'walkingl', 'walkingr', 'sprintingl', 'sprintingr', 'clingsliding', 'clinging'}, to = 'idling'},
    {name= 'walkr', from = {'idling', 'sprintingl', 'sprintingr', 'walkingl'}, to = 'walkingr'},
    {name= 'walkl', from = {'idling', 'sprintingl', 'sprintingr',  'walkingr'}, to = 'walkingl'},
    { name = 'sprintl', from = {'walkingr', 'walkingl', 'idling'}, to = 'sprintingl'},
    { name = 'sprintr', from = {'walkingr', 'walkingl', 'idling'}, to = 'sprintingr'}},
    callbacks = {
        onwalkingl = function() player.xAcc = -.5  end,
        onwalkingr = function() player.xAcc = .5  end,
        onsprintingl = function() player.xAcc = -.7 end,
        onsprintingr = function() player.xAcc = .7 end,
        onstatechange = function(self, event, from, to) lastStateW = from if from == 'walkingr' then xvr = .7 elseif from =='sprintingr' then xvr = 1 elseif from == 'walkingl' then xvl = -.7 elseif from =='sprintingl' then xvl = -1 end end
    },
}
)

    airStates = machine.create({
  initial = 'fallingnj',
  events = {
    { name = 'jump',  from = {'notinair', 'fallingnj'},  to = 'jumping' },
    {name = 'juv', from = 'jumping', to = 'jumpingupv'},
    {name = 'fdv', from = 'jumpingupv', to = 'fallingdownv'},
    { name = 'noair', from = {'fallingdownv', 'fallingdj', 'fallingnj', 'clinging', 'clingsliding'}, to = 'notinair'},
    { name = 'fallnj',  from = {'notinair', 'clinging', 'clingsliding'}, to = 'fallingnj' },
    { name = 'falldj', from = {'jumpingupv','fallingdownv', 'clingsliding','walljumpingl', 'walljumpingr', 'clinging'}, to = 'fallingdj'},
    { name = 'cling', from = {'jumping', 'jumpingupv', 'fallingdowv', 'fallingdj', 'fallingnj', 'walljumpingl', 'walljumpingnr', 'clingsliding'}, to = 'clinging'},
    { name = 'clingslide', from = {'clinging', 'fallingdj', 'fallingnj'}, to = 'clingsliding'},
    {name = 'walljumpl', from = {'clinging', 'clingsliding', 'walljumpingr'}, to = 'walljumpingl'},
    {name = 'walljumpr', from = {'clinging', 'clingsliding', 'walljumpingl'}, to = 'walljumpingr'},
    },
    callbacks = {
        onjumping = function() 
        player.canJump = false
        player.yAcc = -1.5
        yv = -1.5
        timer.after(0.25, function() airStates:juv() end)
        end,
        onfallingnj = function() player.canDJ = false end,
        onclinging = function() if not dashStates:is('dashingup') then player.xAcc = 0 player.yAcc = 0 end end,
        onclingsliding = function() player.yAcc = .4  end,
        onwalljumpingl = function()
        collisionSide = 'air'
        player.yAcc = -1
        player.xAcc = -1
        timer.after(0.3, function() airStates:falldj()end)
        end,
        onwalljumpingr = function()
        player.canWallJumpr = false
        collisionSide = 'air'
        player.yAcc = -1
        player.xAcc = 1
        timer.after(0.3, function() airStates:falldj()end)
    	end,
        onstatechange = function(self, event, from, to) lastStateA = from end
    },
}
)


    dashStates = machine.create({
  initial = 'nodashing',
  events = {
    { name = 'cand',  from = 'nodashing',  to = 'candash' },
    { name = 'nod',  from = {'dashingup', 'dashingupleft', 'dashingupright', 'dashingright', 'dashingleft', 'dashingdownright', 'dashingdown', 'dashingdownleft'},  to = 'nodashing' },
    { name = 'dashu', from = 'candash', to = 'dashingup'},
    { name = 'dashul',  from = 'candase', to = 'dashingupleft' },
    { name = 'dashur',  from = 'candash', to = 'dashingupright' },
    { name = 'dashr',  from = 'candash', to = 'dashingright' },
    { name = 'dashl',  from = 'candash', to = 'dashingleft' },
    { name = 'dashdr',  from = 'candash', to = 'dashingdownright' },
    { name = 'dashd',  from = 'candash', to = 'dashingdown' },
    { name = 'dashdl',  from = 'candash', to = 'dashingdownleft' }
    },
    callbacks = {
        ondashingleft = function() timer.during(.15, function() player.xAcc = -2 end)timer.after(.15, function() dashStates:nod() player.xAcc = 0
        player.yAcc = 0 end) end,
        ondashingright = function() timer.during(.15, function() player.xAcc = 2 end)timer.after(.15, function() dashStates:nod() player.xAcc = 0
        player.yAcc = 0 end) end,
        ondashingup = function() collisionSide = 'air' timer.during(.15, function()  airStates:falldj() player.yAcc = -5 end)timer.after(.15, function()  dashStates:nod() end) end,
        ondashingupright = function() timer.during(.15, function() player.yAcc = -1.5 player.xAcc = 1.5 end)timer.after(.1, function() dashStates:nod() end) end,

    },
}
)

    function velocity(bleb)
        if input:down('right') then xvl = 0 end
        if input:down('left') then xvr = 0 end
        if lastStateW ~= 'idling' then
        if xvr >0 and xvr <=.7 then
        xvr = xvr * (1 - math.min(bleb * FRICTION*2, 1)) player.xAcc = xvr
        end 
        if xvr > .7 then
            xvr = xvr * (1 - math.min(bleb * FRICTION/2, 1)) player.xAcc = xvr 
        end
        if xvl <0 and xvl>=-0.7 then xvl = xvl * (1 - math.min(bleb * FRICTION*2, 1)) player.xAcc = xvl 
        end
        if xvl < -.7 then xvl = xvl * (1 - math.min(bleb * FRICTION/2, 1)) player.xAcc = xvl
        end
        if xvr <= .0001 then xvr = 0 end
        if xvl >= -0.0024752613223432 then xvl = 0 end
    end

        
        if not airStates:is('notinair') then xvl, xvr = 0, 0 end
        if airStates:is('jumpingupv') then 
            if yv < 0 then yv = yv * (1 - math.min(bleb * FRICTION*2, 1)) player.yAcc = yv
            end
            if yv >= -0.00519073427187 then yv = 1 airStates:fdv() end
        end
        if airStates:is('fallingdownv') then 
            if yv < player.gravity then yv = yv * (1 + math.min(bleb * FRICTION*2, 1)) player.yAcc = yv 
            end
            if yv >=2 then yv=0 djornah()  end
        end
        end
    --function findXV() 
       --[[ if walkStates:is('walkingr') then player.xv=1
        elseif walkStates:is('walkingl') then player.xv=-1
        elseif walkStates:is('sprintingr') then player.xv = 2
        elseif walkStates:is('sprintingl') then player.xv = -2
    end end]]
end



function djornah()
    if player.canJump then
        airStates:fallnj()
    else
        airStates:falldj()
    end
end

function love.update(dt)
    player.dx = player.xAcc * player.vel
    player.dy = player.yAcc * player.vel

    player.x, player.y, cols, len = world:move(player, player.x + player.dx, player.y + player.dy)

    --player.xAcc = 0

    if len ~= 0 then
        for i = 1, len do
            local normal = cols[i].normal
            if normal.x == -1 then
                collisionSide = "rwall"
            elseif normal.x == 1 then
                collisionSide = "lwall"
            elseif normal.y == 1 then
                collisionSide = "ceiling"
            elseif normal.y == -1 then
                collisionSide = "floor"
            end

        end
    end

    if player.lastY == player.y and  collisionSide == 'floor' then 
        player.canJump = true
        player.canWallJumpr = false
        player.canWallJumpl = false
        player.isOnGround = true
        player.jumpTimer = player.maxJump
        player.xAcc = 0
    else player.isOnGround = false
    end
    if player.lastX == player.x and collisionSide == 'rwall'
        then player.walledr = true 
            player.canCling = true
            player.canWallJumpr = true
        else
            player.walledr = false
            player.canCling = false
            player.canWallJumpr = false
        end
    if player.lastX == player.x and collisionSide == 'lwall' then
            player.canCling = true
            player.canWallJumpr = true
            player.walledl = true
            player.walledr = false

    else
        player.canWallJumpr = false
        player.walledl = false
    end

    if collisionSide ~= 'rwall' and collisionSide ~= 'lwall' then
            player.walledr = false
            player.walledl = false
            player.walled = false
            player.canCling = false
            
    end
    if collisionSide == nil then
        collisionSide = 'air'
    end
    if collisionSide == 'floor' and not player.isOnGround then
        collisionSide = 'air'
    end

    if not player.walledr and not player.walledl then
        player.walled = false
    end
   function viewVars()
    if viewingVars then
    function debuggo()
    love.graphics.print("walk state: " ..walkStates.current, 0, 0)
    love.graphics.print("air state: " ..airStates.current, 0, 15)
    love.graphics.print("dash state: " .. dashStates.current, 0, 30) 
    love.graphics.print("last state walking: " ..lastStateW, 0, 45)  
    love.graphics.print("last state air: " ..lastStateA, 0, 60)
    love.graphics.print('Collision side: ' .. collisionSide, 0, 75)  
    
    love.graphics.print("xvr is: ".. xvr .. " xvl is: " .. xvl .. ' yv is: '..yv, 0, 90)
    love.graphics.print("player x is: ".. player.x .. " player y is: " .. player.y, 0, 105)
end
else function debuggo()
    end
end
end
    --findXV()
    velocity(dt)
    timer.update(dt)
    map:update(dt)
    player.lastY = player.y
    player.lastX = player.x

    if airStates:is('fallingdj') and ( dashStates:is('candash') or dashStates:is('nodashing'))  or airStates:is('fallingnj') and ( dashStates:is('candash') or dashStates:is('nodashing')) then player.yAcc = player.gravity *dt end  --player.dx = 0
    if player.isOnGround then
        yv= 0
        airStates:noair()
        player.canDJ = true
        dashStates:cand()


    elseif not player.isOnGround and airStates:is('notinair') then
        djornah()
    end
    if player.xAcc == 0 and player.isOnGround then
        walkStates:idle()
    end
    if input:down('quit') then
        love.event.quit()
    end
    
    if input:down('left') and input:down('sprint') and player.isOnGround then
        walkStates:sprintl()
    elseif input:down('right') and input:down('sprint') and player.isOnGround then
        --player.xAcc = 1
        walkStates:sprintr()
    elseif input:down('right') and not airStates:is('clinging') and not airStates:is('clingsliding') and not walkStates:is('dashingr') then
        --player.xAcc = 0.75
        walkStates:walkr()
    elseif input:down('left') and not airStates:is('clinging') and not airStates:is('clingsliding') and not walkStates:is('dashingl') then
        --player.xAcc = -0.75
        walkStates:walkl()
    end
    if input:down('up') and input:down('right') and input:pressed('dash') then
        dashStates:dashur()
    elseif input:down('right') and input:pressed('dash') then
        dashStates:dashr()
    elseif input:down('left') and input:pressed('dash') then
        dashStates:dashl()
    elseif input:down('up') and input:pressed('dash') then
        dashStates:dashu()
    
    end

    if airStates:is('clingsliding') and not player.walledr and not player.walledl then 
        djornah()
    end
    if input:down('jump') and player.canJump then

       airStates:jump()
    end
    
    if input:released('jump') and airStates:is('jumping') then
        yv=-2
        airStates:juv()

    end

    if input:down('cling') and ( collisionSide == 'rwall' or collisionSide == 'lwall') then
        airStates:cling()
    end

    if input:released('cling') then 
      djornah()
    end
    
    if player.walledr and input:down('right') and not input:down('cling') then 
        airStates:clingslide()
    elseif player.walledl and input:down('left') and not input:down('cling') then
        airStates:clingslide()
    end

    if input:pressed('down') and airStates:is('clingsliding') then
        djornah()
    end


    if player.walledr and input:pressed('jump') and airStates:is('clinging') or player.walledr and input:pressed('jump') and airStates:is('clingsliding') then
        airStates:walljumpl()
    end
    if player.walledl and input:pressed('jump') and airStates:is('clinging') or player.walledl and input:pressed('jump') and airStates:is('clingsliding') then
        airStates:walljumpr()
    end

    
   viewVars() 
   if input:pressed('debug') and not viewingVars then
    viewingVars = true
elseif input:pressed('debug') and viewingVars then
    viewingVars = false
end
end

function love.draw()
    
    dx = player.x - (love.graphics.getWidth() / 2) / scale
    dy = player.y - (love.graphics.getHeight() / 2) / scale
 map:draw(-dx, -dy, scale, scale)
    debuggo()
    love.graphics.scale(scale)

    love.graphics.translate(-dx, -dy)

   

    love.graphics.rectangle('fill', player.x, player.y, player.w, player.h)
     
end
